/*
 * s_midi.h
 *
 */

#include <windows.h>
#include <Mmsystem.h>

/*
 *
 */

#define	S_MIDI___	0	/* x */

#define	S_MIDI_C4	0x3c	/* h */
#define	S_MIDI_D4	0x3e	/*  */
#define	S_MIDI_E4	0x40	/* ~ */
#define	S_MIDI_F4	0x41	/* t@ */
#define	S_MIDI_G4	0x43	/* \ */
#define	S_MIDI_A5	0x45	/*  */
#define	S_MIDI_B5	0x47	/* V */
#define	S_MIDI_C5	0x48	/* h */

/*
 *
 */

#define	S_MIDI_LEN_8	500
#define	S_MIDI_LEN_4	(S_MIDI_LEN_8*2)
#define	S_MIDI_LEN_2	(S_MIDI_LEN_4*2)
#define	S_MIDI_LEN_1	(S_MIDI_LEN_2*2)

/*
 *
 */

static int S_midi_init_flag = 0;
static HMIDIOUT S_midi_hMidiOut; /* MIDI o̓foCX̃nh*/
static int S_midi_length = S_MIDI_LEN_4;

/*
 *
 */

static void s_midi_length ( int len ) {

	S_midi_length = len;
}

/*
 *
 */

static void S_midi_atexit() {

  if ( S_midi_init_flag == 1 ) {
	midiOutReset(S_midi_hMidiOut); /* S`lm[gIt*/
	midiOutClose(S_midi_hMidiOut); /* MIDI o̓foCX*/
  }

}

/*
 *
 */

static void S_midi_init() {

  if ( S_midi_init_flag == 0 ) {
	S_midi_init_flag = 1;
	midiOutOpen(&S_midi_hMidiOut, MIDI_MAPPER, 0, 0, 0); /* MIDI o̓foCXJ*/
	atexit ( S_midi_atexit );
  }

}

/*
 *
 */

static void midiStart ( int midi ) {
  int s = 0x007f0090 | ( midi << 8 );

  midiOutShortMsg(S_midi_hMidiOut, s );
}

static void midiStop ( int midi ) {
  int e = 0x007f0080 | ( midi << 8 );

  midiOutShortMsg(S_midi_hMidiOut, e );
}

/*
 *
 */

static void s_midi_play ( int midi ) {

  S_midi_init();

  if ( midi == S_MIDI___ ) {
	Sleep(S_midi_length);
  } else {
	midiStart ( midi );
	Sleep(S_midi_length);
	midiStop ( midi );
  }
}

/*
 *
 */

static void s_midi_harmony ( int a, int b, int c ) {

  S_midi_init();

  midiStart ( a );
  midiStart ( b );
  midiStart ( c );

  Sleep(S_midi_length);

  midiStop ( a );
  midiStop ( b );
  midiStop ( c );

}

/*
 *
 */


